package server;

import java.io.*;
import java.util.ArrayList;
import java.util.Vector;
import java.util.concurrent.*;

public class RepositorioUsers {
	public CopyOnWriteArrayList<User> users;
	private File arquivo;
	private FileInputStream f_inputstream;
	private ObjectInputStream o_inputstream;
	private FileOutputStream f_outstream;
	private ObjectOutputStream o_outstream;

	public RepositorioUsers(String fileName) throws IOException, ClassNotFoundException {
		users = new CopyOnWriteArrayList<User>();
		arquivo = new File(fileName);
		if(!arquivo.exists()){
			arquivo.createNewFile();
			this.users = new CopyOnWriteArrayList<User>();
		}else{
			if(arquivo.length() != 0){
				this.loadFile();
			}else{
				this.users = new CopyOnWriteArrayList<User>();
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void loadFile() throws IOException, ClassNotFoundException {
		f_inputstream = new FileInputStream(arquivo);
		o_inputstream = new ObjectInputStream(f_inputstream);
		Object temp = o_inputstream.readObject();
		
		if(temp instanceof CopyOnWriteArrayList<?>){
			this.users = (CopyOnWriteArrayList<User>)temp;
		}
	}

	public void saveFile() throws IOException {
		f_outstream = new FileOutputStream(arquivo);
		o_outstream = new ObjectOutputStream(f_outstream);
		o_outstream.writeObject(users);
		o_outstream.close();
	}
	public Object[] getList(){
		return this.users.toArray();
	}
	public void adicionar(User x) throws IOException,
			UnnavailableLoginException {
		try {
			if (buscar(x.getLogin()) != null) {

			}
		} catch (Exception e) {
			users.add(x);
			saveFile();
			return;
		}
		throw new UnnavailableLoginException();

	}

	public void remover(String login) throws IOException,
			UsuarioNaoExistenteException {
		for (int i = 0; i < users.size(); i++) {
			User busca = users.get(i);
			if (busca.getLogin().equals(login)) {
				users.remove(i);
				f_outstream = new FileOutputStream(arquivo);
				o_outstream = new ObjectOutputStream(f_outstream);
				saveFile();
				o_outstream.close();
			}
		}
		throw new UsuarioNaoExistenteException();
	}

	public User buscar(String login) throws UsuarioNaoExistenteException {
		for (int i = 0; i < users.size(); i++) {
			User busca = users.get(i);
			if (busca.getLogin().equals(login)) {
				return busca;
			}
		}
		throw new UsuarioNaoExistenteException();
	}

	public void editarSenha(String login, String newSenha)
			throws UsuarioNaoExistenteException, IOException {
		buscar(login).setSenha(newSenha);
		saveFile();
	}

	public void editarEmail(String login, String newMail)
			throws UsuarioNaoExistenteException, IOException {
		buscar(login).setEmail(newMail);
		saveFile();

	}

	public void editarTwitter(String login, String newValue)
			throws UsuarioNaoExistenteException, IOException {
		buscar(login).setTwitter(newValue);
		saveFile();

	}

	public void editarNick(String login, String newValue)
			throws UsuarioNaoExistenteException, IOException {
		buscar(login).setNomeDeExibicao(newValue);
		saveFile();

	}

	public void editarStatus(String login, String newValue)
			throws UsuarioNaoExistenteException, IOException {
		buscar(login).setStatus(newValue);
		saveFile();
	}
	
	public void adicionarAmigo(String login, String newFriend)
	throws UsuarioNaoExistenteException, IOException {
		buscar(newFriend);
		ArrayList<String> contatos = buscar(login).getContatos();
		if(!contatos.contains(newFriend)){
			contatos.add(newFriend);
		}else{
			throw new IOException("Contato j foi adicionado");
		}
	
		saveFile();
	}
	
	public void removerAmigo(String login, String oldFriend)
	throws UsuarioNaoExistenteException, IOException {
		
		buscar(login).getContatos().remove(buscar(oldFriend));
		buscar(oldFriend).getContatos().remove(buscar(login));
		saveFile();
	}
	
	public ArrayList<String> getContatos(String login)
	throws UsuarioNaoExistenteException, IOException {
		return buscar(login).getContatos();

	}
	public static void main(String[] args) throws IOException, ClassNotFoundException, UsuarioNaoExistenteException, UnnavailableLoginException {
		RepositorioUsers repo = new RepositorioUsers("repositorioUSers.data");
		User usuario = new User( "igor.calabria", "123", "coisa@hotmail.com", "@malaaao", "coisa", "offline");
		User usuario2 = new User( "marcel.gay", "123", "coi2sa@hotmail.com", "@malaaao", "coisa", "offline");
		repo.adicionar(usuario);
		repo.adicionar(usuario2);
		//repo.adicionarAmigo("igor.calabria", "marcel.gay");
	}
}
